<!-- 类型选择 -->
<template>
  <a-radio-group
    :value="value"
    @blur="onBlur"
    @update:value="updateValue"
    :options="data"
  />
</template>

<script lang="ts" setup>
  import { ref } from 'vue';
  import { message } from 'ant-design-vue';
  import { listDictionaryData } from '@/api/system/dictionary-data';
  import type { SelectProps } from 'ant-design-vue';

  const emit = defineEmits<{
    (e: 'update:value', value: string): void;
    (e: 'blur'): void;
  }>();

  const props = withDefaults(
    defineProps<{
      value?: string;
      placeholder?: string;
      dictCode?: string;
    }>(),
    {
      placeholder: '请选择'
    }
  );

  // 字典数据
  const data = ref<SelectProps['options']>([]);

  /* 更新选中数据 */
  const updateValue = (value: string) => {
    emit('update:value', value);
  };
  /* 获取字典数据 */
  listDictionaryData({
    dictCode: props.dictCode
  })
    .then((list) => {
      data.value = list.map((d) => {
        return {
          value: d.dictDataCode,
          label: d.dictDataName
        };
      });
    })
    .catch((e) => {
      message.error(e.message);
    });

  /* 失去焦点 */
  const onBlur = () => {
    emit('blur');
  };
</script>
